package com.teamviewer.engage_plugin

import android.app.Activity
import android.graphics.Bitmap
import android.graphics.Canvas
import android.view.View
import com.chatvisor.android.cobrowsing.screenObserver.IScreenGrabObserver
import io.flutter.embedding.engine.renderer.FlutterRenderer

class FlutterScreenGrabObserver: IScreenGrabObserver {
    var renderingEngine : Any? = null
    override fun updateRenderingEngine(renderingEngine: Any?) {
        this.renderingEngine = renderingEngine
    }
    override fun grabScreen(activity: Activity?): Bitmap {
        var bitmapFlutter: Bitmap? = null
        val currentActivity = activity ?: throw Exception("Activity is null")
        val window = currentActivity.window
        val view = window.decorView.rootView
        val bitmapNative: Bitmap = takeScreenShot(view)
        if (this.renderingEngine?.javaClass.toString().contains("FlutterRenderer")) {
            bitmapFlutter = (this.renderingEngine as FlutterRenderer).bitmap
        }
        return if (bitmapFlutter == null){
            bitmapNative
        }else{
            mergeBitmaps(bitmapFlutter, bitmapNative)
        }
    }

    private fun takeScreenShot(view: View): Bitmap {
        val bitmap = Bitmap.createBitmap(
            view.width,
            view.height,
            Bitmap.Config.ARGB_8888
        )
        val canvas = Canvas(bitmap)
        view.draw(canvas)
        return bitmap
    }

    private fun mergeBitmaps(back: Bitmap, front: Bitmap): Bitmap {
        val result = Bitmap.createBitmap(back.width, back.height, back.config)
        val canvas = Canvas(result)
        val widthBack = back.width
        val widthFront = front.width
        val move = ((widthBack - widthFront) / 2).toFloat()
        canvas.drawBitmap(back, 0f, 0f, null)
        canvas.drawBitmap(front, move, move, null)
        return result
    }

}