import 'engage_plugin_platform_interface.dart';

class InitConfig {
  String tenantId;
  String token;
  String? serverUrl;
  String? cdnServerUrl;
  bool? chatOverlayVisible;
  List<String>? deeplinkUrls;
  String? overlayBackgroundColor;
  String? controlsColor;

  InitConfig(this.tenantId, this.token,
      [this.serverUrl,
      this.cdnServerUrl,
      this.chatOverlayVisible,
      this.deeplinkUrls,
      this.overlayBackgroundColor,
      this.controlsColor]);
}

class TagUserInfo {
  List<String> labels;
  String email;
  String firstName;
  String lastName;
  String id;
  String assignedUser;
  String externalToken;
  Map<String, String> additionalTaggingData;
  TagUserInfo(this.labels, this.email, this.firstName, this.lastName, this.id,
      this.assignedUser, this.externalToken, this.additionalTaggingData);
}

class EngagePlugin {
  Future<void> init(InitConfig config) {
    return EngagePluginPlatform.instance.init(config);
  }

  Future<void> openChat() {
    return EngagePluginPlatform.instance.openChat();
  }

  Future<void> closeChat() {
    return EngagePluginPlatform.instance.closeChat();
  }

  Future<void> startCoBrowsing() {
    return EngagePluginPlatform.instance.startCoBrowsing();
  }

  Future<void> stopCoBrowsing() {
    return EngagePluginPlatform.instance.stopCoBrowsing();
  }

  Future<void> tagUser(TagUserInfo info) {
    return EngagePluginPlatform.instance.tagUser(info);
  }

  Future<void> clear() {
    return EngagePluginPlatform.instance.clear();
  }
}
