import 'package:engage_plugin/engage_plugin.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'engage_plugin_method_channel.dart';

abstract class EngagePluginPlatform extends PlatformInterface {
  EngagePluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static EngagePluginPlatform _instance = MethodChannelEngagePlugin();

  static EngagePluginPlatform get instance => _instance;

  static set instance(EngagePluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<void> init(InitConfig config) {
    throw UnimplementedError('Init has not been implemented');
  }

  Future<void> openChat() {
    throw UnimplementedError('Chat has not been implemented');
  }

  Future<void> closeChat() {
    throw UnimplementedError('Chat has not been implemented');
  }

  Future<void> startCoBrowsing() {
    throw UnimplementedError('Start CoBroswer has not been implemented');
  }

  Future<void> stopCoBrowsing() {
    throw UnimplementedError('Stop CoBroswer has not been implemented');
  }

  Future<void> tagUser(TagUserInfo info) {
    throw UnimplementedError('Tag user has not been implemented');
  }

  Future<void> clear() {
    throw UnimplementedError('Clear user has not been implemented');
  }
}
