import 'package:flutter_test/flutter_test.dart';
import 'package:engage_plugin/engage_plugin.dart';
import 'package:engage_plugin/engage_plugin_platform_interface.dart';
import 'package:engage_plugin/engage_plugin_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockEngagePluginPlatform
    with MockPlatformInterfaceMixin
    implements EngagePluginPlatform {
  @override
  Future<void> init(InitConfig config) {
    throw UnimplementedError();
  }

  @override
  Future<void> openChat() {
    throw UnimplementedError();
  }

  @override
  Future<void> startCoBrowsing() {
    throw UnimplementedError();
  }

  @override
  Future<void> stopCoBrowsing() {
    throw UnimplementedError();
  }

  @override
  Future<void> tagUser(TagUserInfo info) {
    throw UnimplementedError();
  }

  @override
  Future<void> clear() {
    throw UnimplementedError();
  }

  @override
  Future<void> closeChat() {
    throw UnimplementedError();
  }
}

void main() {
  final EngagePluginPlatform initialPlatform = EngagePluginPlatform.instance;

  test('$MethodChannelEngagePlugin is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelEngagePlugin>());
  });

  test('getEngagePlugin', () async {
    MockEngagePluginPlatform fakePlatform = MockEngagePluginPlatform();
    EngagePluginPlatform.instance = fakePlatform;
  });
}
